VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Select Font"
      Height          =   495
      Left            =   2160
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
   Begin MSComDlg.CommonDialog dlgFont 
      Left            =   4080
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label1 
      Caption         =   "Click the button below to select a new font"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5175
      Left            =   3000
      TabIndex        =   1
      Top             =   1920
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal I As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Const FW_NORMAL = 400
Private Const FW_BOLD = 700

Private m_FontName As String
Private m_FontSize As Long
Private m_FontWeight As Long
Private m_FontItalic As Boolean
Private m_FontUnderline As Boolean
Private m_FontStrikethrough As Boolean

Private Const SAMPLE_TEXT = "Only TrueType fonts can be rotated"
Private Sub DrawRotatedText(ByVal txt As String, _
    ByVal X As Single, ByVal Y As Single, _
    ByVal font_name As String, ByVal size As Long, _
    ByVal weight As Long, ByVal escapement As Long, _
    ByVal use_italic As Boolean, ByVal use_underline As Boolean, _
    ByVal use_strikethrough As Boolean)

Const CLIP_LH_ANGLES = 16   ' Needed for tilted fonts.
Const PI = 3.14159625
Const PI_180 = PI / 180#

Dim newfont As Long
Dim oldfont As Long

    newfont = CreateFont(size, 0, _
        escapement, escapement, weight, _
        use_italic, use_underline, _
        use_strikethrough, 0, 0, _
        CLIP_LH_ANGLES, 0, 0, font_name)
    
    ' Select the new font.
    oldfont = SelectObject(hdc, newfont)
    
    ' Display the text.
    CurrentX = X
    CurrentY = Y
    Print txt

    ' Restore the original font.
    newfont = SelectObject(hdc, oldfont)
    
    ' Free font resources (important!)
    DeleteObject newfont
End Sub

Private Sub Command1_Click()
    ' Initialize the dialog's properties.
    With dlgFont
        .FontName = m_FontName
        .FontSize = m_FontSize
        .FontBold = (m_FontWeight > FW_NORMAL)
        .FontItalic = m_FontItalic
        .FontUnderline = m_FontUnderline
        .FontStrikethru = m_FontStrikethrough
    End With

    dlgFont.Flags = cdlCFScreenFonts Or cdlCFTTOnly
    dlgFont.CancelError = True
    On Error Resume Next
    dlgFont.ShowFont
    If Err = cdlCancel Then Exit Sub

    ' Use the dialog's properties.
    With dlgFont
        m_FontName = .FontName
        m_FontSize = .FontSize
        If .FontBold Then
            m_FontWeight = FW_BOLD
        Else
            m_FontWeight = FW_NORMAL
        End If
        m_FontItalic = .FontItalic
        m_FontUnderline = .FontUnderline
        m_FontStrikethrough = .FontStrikethru

        Cls
        DrawRotatedText SAMPLE_TEXT, _
            m_FontSize, 20, m_FontName, m_FontSize, _
            m_FontWeight, -900, _
            m_FontItalic, m_FontUnderline, m_FontStrikethrough
    End With
End Sub


Private Sub Form_Load()
    AutoRedraw = True
    ScaleMode = vbPoints

    m_FontName = "Times New Roman"
    m_FontSize = 20
    m_FontWeight = FW_NORMAL
    m_FontItalic = False
    m_FontUnderline = False
    m_FontStrikethrough = False

    DrawRotatedText SAMPLE_TEXT, _
        m_FontSize, 20, m_FontName, m_FontSize, _
        m_FontWeight, -900, _
        m_FontItalic, m_FontUnderline, m_FontStrikethrough
End Sub


